import Server from './framework/express/server';
import ip from 'ip';
import UserModel from './framework/mongo/user';
import { MongoClient } from 'mongodb';

const PORT = 8000;
const MONGOURI = 'mongodb://localhost:27017';
const DBNAME = 'dev';

export type Services = {
  userModel: UserModel;
};

const mongo = new MongoClient(MONGOURI);
const db = mongo.db(DBNAME);

const services: Services = {
  userModel: new UserModel(db),
};

const server = new Server(services);

server.start(PORT, () =>
  console.log(
    `Running on http://127.0.0.1:${PORT} http://${ip.address()}:${PORT}`,
  ),
);
