import express, { Express } from 'express';
import cors from 'cors';
import * as router from './router';
import { BeforeEach } from './middleware';
import { Services } from '../../app';

class Server {
  private app: Express;

  constructor(services: Services) {
    this.app = express();
    this.app.use(express.json());
    this.app.use(cors());
    this.app.use(BeforeEach());
    this.app.use(router.getRoutes(services));
  }

  start(port: number, func: () => void): void {
    this.app.listen(port, func);
  }
}

export default Server;
