import { RequestHandler, Router } from 'express';
import { Services } from '../../app';
import { Create } from '../../functions/user';
import { getId } from './middleware';

export function LoginHandler(services: Services): RequestHandler {
  return async (req, res) => {
    return res.send('Hey!\n');
  };
}

export function CreateHandler(services: Services): RequestHandler {
  const createUser = Create(services);

  return async (req, res) => {
    const user = await createUser(getId(req), req.body);

    res.send(user);
  };
}

export function getRoutes(services: Services) {
  const router = Router();

  router.post('/login', LoginHandler(services));
  router.post('/create', CreateHandler(services));

  return router;
}
