import { Collection, Db } from 'mongodb';
import { User } from '../../entities/user';

class UserModel {
  private collection: Collection<User>;

  constructor(db: Db) {
    this.collection = db.collection<User>('users');
  }

  public async create(tracker: string, user: User) {
    await this.collection.insertOne(user);
    return this.read(tracker, user.uuid);
  }

  public async read(tracker: string, uuid: string) {
    const user = await this.collection.findOne({ uuid });
    return new User(user || { name: 'not found' });
  }
}

export default UserModel;
